public interface IMoveableObject {
    ObjectParameters GetObjectPosition();
    /// <summary>
    /// Шаг объекта
    /// </summary>
    int GetStep();
    /// <summary>
    /// Проверка, можно ли переместиться по нужному направлению
    /// </summary>
    /// <param name="direction"></param>
    /// <returns></returns>
    boolean CheckCanMove(Direction direction);
    /// <summary>
    /// Изменение направления пермещения объекта
    /// </summary>
    /// <param name="direction">Направление</param>
    void MoveObject(Direction direction);
}
